{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}

// QSaver 2.4.10 by A.Ruzanov
// 16.06.2010

unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IF Defined(KOL_MCK)}{$ELSE}, mirror, Classes, Controls, mckCtrls, mckObjs, Graphics {$IFEND (place your units here->)}, KolPng, ShellAPI, tlhelp32;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  TEnumData = record
    ProcId: DWord;
    Title: string;
    Wnd, WndEdit, WndCombo, WndScreen: HWND;
  end;
  PEnumData = ^TEnumData;
  {$IF Defined(KOL_MCK)}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TForm1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$IFEND KOL_MCK}
    Qsaver: TKOLProject;
    KOLForm1: TKOLForm;
    EditBox1: TKOLEditBox;
    EditBox2: TKOLEditBox;
    CheckBox1: TKOLCheckBox;
    CheckBox2: TKOLCheckBox;
    Button3: TKOLButton;
    Button4: TKOLButton;
    Button1: TKOLButton;
    Button2: TKOLButton;
    CheckBox3: TKOLCheckBox;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    CheckBox4: TKOLCheckBox;
    Label3: TKOLLabel;
    CheckBox5: TKOLCheckBox;
    procedure KOLForm1BeforeCreateWindow(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure Button4Click(Sender: PObj);
    procedure CheckBox3Click(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
    procedure CheckBox4Click(Sender: PObj);
    procedure CheckBox2Click(Sender: PObj);
    procedure Label3Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  WrongChar = [#0..#31, ':', '\', '/', '<', '>', '?', '*', '|', '"', '#'];
  TrimChar = [#0..#32, #46, #95, #160];
  QsErr = 'QSaver Error';
var
  FolderForPages, FolderForImages: String;
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

function UrlUnescapeA(pszUrl, pszUnescaped: PAnsiChar; pcchUnescaped: LPDWORD;
  dwFlags: DWORD): HRESULT; stdcall; external 'shlwapi.dll' name 'UrlUnescapeA';

function UrlUnescape(Url: String): String;
 var
  buf: Array [0..4095] Of Char;
  sz: Integer;
begin
  sz := SizeOf(buf);
  UrlUnescapeA(PChar(Url), buf, @sz, $02000000);
  Result := buf;
end;

procedure ExecAndWait(const CommndLine: String; ShowCmd: Integer);
var 
 pi : TProcessInformation;
 si : TStartupInfo; 
 msg: TMsg;
begin
 ZeroMemory(@si,sizeof(si));
 si.cb:=SizeOf(si);  
 si.dwFlags := STARTF_USESHOWWINDOW;  
 si.wShowWindow := ShowCmd;
 if not CreateProcess(
 nil, //pointer to name of executable module
 PChar(CommndLine), // Command line.
 nil, // Process handle not inheritable.
 nil, // Thread handle not inheritable.
 False, // Set handle inheritance to FALSE.
 0, // No creation flags.
 nil, // Use parent's environment block.
 nil, // Use parent's starting directory.
 si, // Pointer to STARTUPINFO structure.
 pi ) // Pointer to PROCESS_INFORMATION structure.
 then Exit;
 while WaitforSingleObject(PI.hProcess,100)=WAIT_TIMEOUT do If PeekMessage(msg, 0, 0, 0, PM_REMOVE) Then
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
 CloseHandle(pi.hProcess);
 CloseHandle(pi.hThread);
end;

function CommandLine: String;
 var P: PChar;
begin
  P := SkipSpaces( GetCommandLine );
  while P[0] > ' ' do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
        Inc(P);
      if P[0] <> #0 then Inc(P);
    end
      else
      Inc(P);
  Result := P;
end;

function CorrectPath(const Str, Root: string): string;
 var
  Sz, K: Integer;
  Buffer: PChar;
begin
  Sz := ExpandEnvironmentStrings(PChar(Str),nil,0);
  GetMem(Buffer,Sz);
  ExpandEnvironmentStrings(PChar(Str), Buffer, Sz);
  Result := Buffer;
  FreeMem(Buffer);

  K := RegKeyOpenRead(HKEY_CURRENT_USER, 'SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders');
  StrReplace(Result, '%DesktopDir%', ExcludeTrailingPathDelimiter(RegKeyGetStr(K, 'Desktop')));
  StrReplace(Result, '%MyDocuments%', ExcludeTrailingPathDelimiter(RegKeyGetStr(K, 'Personal')));
  RegKeyClose(K);

  If Trim(Result) = '' Then Result := Root;
  If Pos(':\', Result) = 0 Then Result := IncludeTrailingPathDelimiter(Root)+Result;
end;

function ReverseString(const AText: string): string;
var
  I: Integer;
  P: PChar;
begin
  SetLength(Result, Length(AText));
  P := PChar(Result);
  for I := Length(AText) downto 1 do
  begin
    P^ := AText[I];
    Inc(P);
  end;
end;

function PosR(const FindS, SrcS: string): Integer;
var
  ps: Integer;
begin
Result := 0;
ps := Pos(ReverseString(FindS), ReverseString(SrcS));
if ps <> 0 then Result := Length(SrcS) - Length(FindS) - ps + 2;
end;

function TrimR(const S: KOLstring): KOLstring;
var
  I: Integer;
begin
  I := Length(S);
  while (I > 0) and (S[I] in TrimChar) do Dec(I);
  Result := Copy(S, 1, I);
end;

function TrimL(const S: KOLstring): KOLstring;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] in TrimChar) do Inc(I);
  Result := Copy(S, I, Maxint);
end;

function NeedCorrectName(const S : String): Boolean;
var I, L: Integer;
begin
L := Length(S);
Result := (L > 200);
if not Result then
  for I := 1 to L do if S[I] in WrongChar then
    begin
    Result := True;
    Break;
    end;
end;

function CorrectName(const St: String): String;
var
  I: Integer;
  S: String;
begin
  S := St;
  for I := Length(S) downto 1 do if S[I] in WrongChar then S[I] := '_';
  while Pos('__', S) <> 0 do StrReplace(S, '__', '_');
  Result := TrimL(TrimR(Copy(S, 1, 128)));
end;

function CorrectDot(const S: String): String;
var I: Integer;
begin
  Result := S;
  for I := Length(Result) downto 1 do if Result[I] = '.' then Result[I] := '_';
  while Pos('__', Result) <> 0 do StrReplace(Result, '__', '_');
end;

function CorrHostName(const Str: string): string;
var
  P: Integer;
  S: String;
begin
  If (Pos('opera:', Str) = 1) Or (Pos('about:', Str) = 1) Then S := Copy(Str, 1, 32)
  Else
    begin
    S := Copy(Str, Pos('://', Str)+3, Length(Str));
    P := Pos('/', S);
    If P > 32 Then P := 32;
    S := Copy(S, 1, P-1);
    StrReplace(S, 'www.', '');
    end;
  If S <> '' Then Result := IncludeTrailingPathDelimiter(CorrectName(S));
end;

function QuickSaveName(const S: String): String;
var i: Integer;
begin
i := 0;
Result := S;
while FileExists(Result) do
  begin
    inc(i);
    Result := ExtractFilePath(S)+ExtractFileNameWOext(S)+'_'+int2str(i)+ExtractFileExt(S);
  end;
end;

function NotHtmExt(const Extension: String): Boolean;
var Ext: String;
begin
Ext := LowerCase(Extension);
Result := (Ext <> '.htm') And (Ext <> '.html') And (Ext <> '.shtml') And  (Ext <> '.dhtml') And
  (Ext <> '.mht') And (Ext <> '.mhtml') And (Ext <> '.txt') And (Ext <> '.xml') And (Ext <> '.php');
end;

function NotMmExt(const Extension: String): Boolean;
var Ext: String;
begin
Ext := LowerCase(Extension);
Result := (Ext <> '.jpg') And (Ext <> '.jpeg') And (Ext <> '.gif') And (Ext <> '.png') And
  (Ext <> '.bmp') And (Ext <> '.svg') And (Ext <> '.svgz') And (Ext <> '.avi') And
  (Ext <> '.wav') And (Ext <> '.mid') And (Ext <> '.midi') And (Ext <> '.win') And
  (Ext <> '.swf') And (Ext <> '.torrent') And (Ext <> '.js') And (Ext <> '.css');
end;

// Fix for Opera 9.50
function WrongExt(const text, sFormat: String): Boolean;
var Ext: String;
begin
Ext := LowerCase(ExtractFileExt(text));
Result := ((Ext = '.mht') And (sFormat <> 'mht')) Or
   ((Ext = '.htm') And (sFormat <> 'htm') And (sFormat <> 'html')) Or
   ((Ext = '.txt') And (sFormat <> 'txt'));
end;


function GetParentId: DWord;
var
  ProcEntry: TProcessEntry32;
  hSnapshot: THandle;
  CurrID: DWord;
begin
  Result := 0;
  hSnapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if (hSnapshot <> INVALID_HANDLE_VALUE) then
    try
      ProcEntry.dwSize := SizeOf(ProcEntry);
      CurrID := GetCurrentProcessId;
      if Process32First(hSnapshot, ProcEntry) then
        repeat
          if ProcEntry.th32ProcessID = CurrID then
            begin
             Result := ProcEntry.th32ParentProcessID;
             Break;
            end;
        until not Process32Next(hSnapshot, ProcEntry);
    finally
     CloseHandle(hSnapshot);
    end;
end;

function FindOpera(Wnd: HWnd; Param: PEnumData): Boolean; stdcall;
var
    WinText, WinClass: Array[0..255] of Char;
    WinTextLen, WinClassLen: Integer;
    ProcessId: DWord;
begin
Result := True;
ProcessId := 0;
if Param.ProcId > 0 then GetWindowThreadProcessId(Wnd, @ProcessId);
if Param.ProcId = ProcessId then
  begin
  WinTextLen := GetWindowText(Wnd, WinText, SizeOf(WinText));
  WinClassLen := GetClassName(Wnd, WinClass, SizeOf(WinClass));

  if isWindow(Wnd) and IsWindowVisible(Wnd) and (WinTextLen <> 0) and (WinClassLen <> 0) then
      Result := ((WinClass <> 'OpWindow') and (WinClass <> 'OperaWindowClass')) or (WinText = '');
  end;
if not Result then Param.Wnd := Wnd;
end;

function GetHndls(Wnd: hWnd; Param: PEnumData): Bool; stdcall;
var
  WinClass: Array[0..255] of Char;
  WinClassLen: Integer;
begin
WinClassLen := GetClassName(Wnd, WinClass, SizeOf(WinClass));
If (WinClassLen <> 0) and (WinClass = 'Edit') Then Param.WndEdit := Wnd;
If (WinClassLen <> 0) and (WinClass = 'ComboBox') Then Param.WndCombo := Wnd;
Result := True;
end;

function GetChildWindow(Wnd: hWnd; Param: PEnumData): Bool; stdcall;
var
  str: String;
  len: Integer;
begin
  len := GetWindowTextLength(Wnd);
  if len > 0 then
    begin
    SetString(str, nil, len);
    GetWindowText(Wnd, PChar(str), len + 1 );
    end;
  Result := (str <> Param.Title);
  if not Result then Param.WndScreen := Wnd;
end;


procedure GetScreenShot(const AHandle: THandle; FileName: String; all: Boolean = false);
var
  Bmp: PBitmap;
  DC: HDC;
  Rect, wRect: TRect;
  Image: PPngObject;
  Width, Height, XSrc, YSrc: Integer;

begin
  If all Then DC := GetWindowDC(AHandle) Else DC := GetDC(AHandle);
  if DC <> 0 then
    try
      if all then
        begin
        if not GetWindowRect(AHandle, wRect) then Exit;
        IntersectRect(Rect, wRect, GetWorkArea);
        XSrc := Rect.Left - wRect.Left;
        YSrc := Rect.Top - wRect.Top;
        end
      else
        begin
        if not GetClientRect(AHandle, Rect) then Exit;
        XSrc := 0;
        YSrc := 0;
        end;

      Width := Rect.Right - Rect.Left;
      Height := Rect.Bottom - Rect.Top;
      Bmp := NewDIBBitmap(Width, Height, pf24bit);
      if BitBlt(Bmp.Canvas.Handle, 0, 0, Width, Height, DC, XSrc, YSrc, SRCCOPY) then
        begin
        Image := NewPngObject;
        Image.AssignHandle(Bmp.Handle, false, 0);
        Image.SaveToFile(FileName);
        Image.Free;
        end;
      Bmp.Free;
    finally
      ReleaseDC(AHandle, DC);
    end;
end;

function GetAllFiles(Folder: String): String;
var
   DirList: pDirList;
   I: Integer;
begin
  Result := '';
  DirList := NewDirList(Folder, '*.*', 0);
    for I := 0 to DirList.Count-1 do
      begin
      If LongBool(DirList.Items[I].dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) Then
        Result := Result + GetAllFiles(DirList.Path + DirList.Names[I])
      Else
        Result := Result + #13#10 + DirList.Path + DirList.Names[I];
      end;
  DirList.Free;
end;

procedure CorrectHtmlFiles(Folder: String);
const
  js = '<script type="text/javascript">window.onerror=function(){return true}</script>';
var
   DirList: pDirList;
   I, posHead: Integer;
   Str: string;
begin
  DirList := NewDirList(Folder, '*.*', 0);
    for I := 0 to DirList.Count-1 do
      begin
      If LongBool(DirList.Items[I].dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) Then
        CorrectHtmlFiles(DirList.Path + DirList.Names[I])
      Else
        If Not NotHtmExt(ExtractFileExt(DirList.Names[I])) Then
          begin
            Str := StrLoadFromFile(DirList.Path + DirList.Names[I]);
            posHead := Pos('<head>', LowerCase(Str));
            If posHead <> 0 Then StrSaveToFile(DirList.Path + DirList.Names[I], Copy(Str, 1, posHead+5)+js+Copy(Str, posHead+6, Maxint));
          end;
      end;
  DirList.Free;
end;

function GetFolderSize( const Path: KOLString ): Int64;
var DirList: PDirList;
    I: Integer;
begin
  Result := 0;
  DirList := NewDirList( Path, '*.*', 0 );
  for I := 0 to DirList.Count-1 do
  begin
    If LongBool(DirList.Items[I].dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) Then
      Result := Result + GetFolderSize(DirList.Path + DirList.Names[I])
    Else
      Result := Result + ( (DirList.Items[I].nFileSizeHigh shl 32) + DirList.Items[I].nFileSizeLow );
  end;
  DirList.Free;
end;


function GetUniqTmpFolder(const path: String): String;
var i: Integer;
    s: String;
begin
i := 0;
s := IncludeTrailingPathDelimiter(path)+'_temp_';
Result := s;
while DirectoryExists(Result) do
  begin
    inc(i);
    Result := s+int2str(i);
  end;
end;


procedure SaveAddFile(rez, url: String);
const
  h = '<html><frameset><frame src="';
  e = '"></frameset></html>'+#13#10+'<!-- This document saved from ';
var
  fp: String;
begin
fp := ExtractFilePath(rez);
DeleteTail(fp, 7);
StrSaveToFile(fp+'.html', h+ExtractFileName(fp)+'_files/'+ExtractFileName(rez)+e+url+' -->');
end;


procedure AddToHistory(ttle, localurl, url, rootdir: String; all, invert: Boolean);
const
  EndHtm= '</div></body></html>';
var
  I, indx, PozSep, PozStart, PozEnd: Integer;
  data, str, filename, tmpname, MStr: String;
  Strm, Mstream: PStream;
begin
If ((Pos('http', url) <> 1) And (Pos('ftp', url) <> 1) And (Pos('file', url) <> 1)) Or (TrimR(url) = TrimR(ttle)) Then url := '';

If all Or (ttle = '') Then ttle := ExtractFileNameWOext(localurl);
while Pos('<', ttle) <> 0 do StrReplace(ttle, '<', '&lt;');
while Pos('>', ttle) <> 0 do StrReplace(ttle, '>', '&gt;');
StrReplace(localurl, rootdir, '');

If Pos(':\', localurl) = 2 Then localurl := 'file://localhost/'+localurl;
for I := Length(localurl) downto 1 do if localurl[I] = '\' then localurl[I] := '/';
while Pos(' ', localurl) <> 0 do StrReplace(localurl, ' ', '%20');

filename := rootdir+'QSaverHistory.html';
tmpname := filename+'.tmp';
data := '<h2>'+AnsiToUtf8(Date2StrFmt('dddd dd.MM.yyyy', Date))+'</h2>';

If FileExists(tmpname) Then CopyFile(PChar(tmpname), PChar(ReplaceExt(filename, '.bak')), false);
If FileSize(filename)>0 Then CopyFile(PChar(filename), PChar(tmpname), false);

If (Not FileExists(filename)) Or (FileSize(filename)=0) Then
begin
Strm := NewWriteFileStream(filename);
Resource2Stream(Strm,hInstance,PChar('QSHISTORY'),RT_RCDATA);
Strm.Free;
end;

with NewStrList^ do begin
  LoadFromFile(filename);
// Upgrade QSaverHistory.html
  If (Count > 4) And (Pos('QSaver history ver 2.4+', Items[4])=0) Then
    begin
    CopyFile(PChar(filename), PChar(filename+'.old'), (FileExists(filename+'.old') And (FileSize(filename) < FileSize(filename+'.old'))));
    Mstream := NewMemoryStream;
    Resource2Stream(Mstream,hInstance,PChar('QSHISTORY'),RT_RCDATA);
    Mstream.Position := 0;
    MStr := Mstream.ReadStrZ;
    Mstream.Free;
    PozSep := Pos(EndHtm, MStr);
    PozStart := Pos('<h2>', Text);
    PozEnd := PosR('</table>', Text);
    If (PozSep = 0) Or (PozStart = 0) Or (PozEnd = 0) Then
      begin
      MessageBox( 0, PChar('Unable to update QSaverHistory.html!'), QsErr,  48 );
      Halt;
      end;
    Text := Copy(MStr, 1, PozSep-1)+Copy(Text, PozStart, PozEnd+9-PozStart)+Copy(MStr, PozSep, MaxInt);
    end;

  If IndexOf(data) = -1 Then
   begin
    If invert Then indx := IndexOf('<div id="content"><script type="text/javascript">init();</script>')+1 Else indx := IndexOf(EndHtm);
    Insert(indx, '</table>');
    Insert(indx, '<table>');
    Insert(indx, data);
   end;
  str := '<tr><td>'+Time2StrFmt('HH:mm:ss', Now)+'</td>'+#13#10+'<td><a href="'+
  localurl+'" target="_blank"><b>'+ttle+'</b><br>'+url+'</a>'+#13#10+'</td></tr>';

  If invert Then Insert(IndexOf('<table>')+1, AnsiToUtf8(str)) Else Insert(IndexOf(EndHtm)-1, AnsiToUtf8(str));
  SaveToFile(filename);
  Free;
  end;
DeleteFile(PChar(tmpname));
end;


procedure AddToDescription(localurl, url: String; old: Boolean);
var Path, DescName, Name, Str: String;
begin
If old Then
  begin
  Path := ExtractFilePath(localurl);
  DeleteTail(Path, 7);
  Path := Path+'.html'
  end
Else
  Path := localurl;

DescName := ExtractFilePath(Path)+'descript.ion';
Name := ExtractFileName(Path);
If Pos(' ', Name) <> 0 Then Name := '"'+Name+'"';
Str := '';

If FileExists(DescName) Then
  begin
  SetFileAttributes(PChar(DescName), FILE_ATTRIBUTE_NORMAL);
  Str := StrLoadFromFile(DescName);
  If (Str <> '') And (Str[Length(Str)] <> #10) Then Str:= Str + #13#10;
  end;
StrSaveToFile(DescName, Str + Name + ' ' + url + #13#10);
SetFileAttributes(PChar(DescName), FILE_ATTRIBUTE_HIDDEN);
end;


function GetParam(const cLine, param: String): String;
var poz, len: Integer;
    startStr, endStr: String;
begin
Result := '';
If Length(param) > 0 Then
  begin
  If (Pos('', cLine) <> 0) And (Pos('', cLine) <> 0) Then
    begin
    startStr := '/'+param+'=';
    endStr := '';
    end
  Else
    begin
    startStr := '/'+param+'=''''';
    endStr := '''''';
    end;

  poz := Pos(startStr, cLine);
  If poz = 0 Then
    begin
    startStr := '/'+param+'=';
    endStr := ' ';
    poz := Pos(startStr, cLine);
    end;
  If poz > 0 Then
    begin
    Result := Copy(cLine, poz+Length(startStr), MaxInt);
    poz := Pos(endStr, Result);
    If poz > 0 Then SetLength(Result, poz-1);
    len := Length(Result);
    If (len >= 2) And (Result[1]='"') And (Result[len]='"') Then Result := Copy(Result, 2, len-2);
    end;
  end;
end;


procedure Lang(eng: Boolean);
var ini: pIniFile;
    wh, wd, nt, ca, fp, fi, oh: String;
begin
If eng Then
  begin
  wh := 'Write down history of saving';
  wd := 'Write address of page in descript.ion file';
  nt := 'Reverse order in QsaverHistory (newest at the top)';
  ca := 'Cancel';
  fp := 'Folder for quick saving of pages';
  fi := 'Folder for quick saving of images';
  oh := 'Open QsaverHistory';
  end
Else
  begin
  wh := '  ';
  wd := '     descript.ion';
  nt := '     ';
  ca := '';
  fp := '    ';
  fi := '    ';
  oh := ' ';
  end;

ini := OpenIniFile(ReplaceExt(ParamStr(0), '.ini'));
ini.Mode := ifmRead;
If eng Then ini.Section := 'English' Else ini.Section := 'Language';
Form1.CheckBox1.Caption := ini.ValueString('WriteHistory', wh)+'.';
Form1.CheckBox4.Caption := ini.ValueString('WriteDescription', wd);
Form1.CheckBox5.Caption := ini.ValueString('NewestAtTheTop', nt);
Form1.Button4.Caption := ini.ValueString('Cancel', ca);
Form1.Label1.Caption := ini.ValueString('ForPages', fp)+':';
Form1.Label2.Caption := ini.ValueString('ForImages', fi)+':';
Form1.Label3.Caption := ini.ValueString('OpenHistory', oh);
ini.Free;
end;


procedure TForm1.KOLForm1BeforeCreateWindow(Sender: PObj);
begin
Form.Font.FontHeight := 13;
end;


procedure TForm1.KOLForm1FormCreate(Sender: PObj);
const
  hlp = 'QSaver for Opera Ver 2.4'+#13#13+
  'QSaver.exe /format=html /method=folder /url=''''%U'''' /path=''''c:\web'''' /text=''''%T'''''+#13+
  'QSaver.exe /format=chm /method=quick /url=''''%U'''' /text=''''%T'''''+#13+
  'QSaver.exe /format=mht /method=all'+#13+
  'QSaver.exe /format=png /text=''''%T''''';
  VK_S = $53;
  settStart = '<!-- QSaver settings ';
  settEnd = ' -->';
var
  RecOpera: TEnumData;
  OpWnd, OpWinWnd, SaveWnd, Ewnd, SelWnd: HWND;
  time, TimeOut, maxTime: dword;
  TitleLen, Tip, j, k, settPos, operaPos: Integer;
  quick, folder, folderTime, folderName, all, simple, OperaOld, History, img,
  English, Description, ReverseOrder, js, CheckParent: Boolean;
  Qsini: pIniFile;
  OSD: POpenSaveDialog;
  tmpSize: Int64;
  SaveTitle, SaveClass, text: Array [0..255] Of Char;
  Title, QuickSaveDir, QuickSaveImgDir, NameFile, Ext, rez, fn, QuickText, Fext, DefExt,
  Param1, QsaverIni, RootQsd, RezTitle, cLine, sFormat, sMethod, sText, sUrl, sPath,
  startDir, html, qsett, tmpFolder, converter, convSett, convSettPath, convCmdLine,
  ChmOptions, IsiloOptions: String;

begin

If ParamCount = 1 Then Param1 := ParamStr(1) Else Param1 := '';
If (Param1 = '--help') Or (Param1 = '/?') Then
  begin
  MessageBox( 0, PChar(hlp), 'About',  64 );
  Halt;
  end;

startDir := GetStartDir;
QsaverIni := ReplaceExt(ParamStr(0), '.ini');

cLine := CommandLine;
// Save via js
js := Pos('data:text/qsv;charset=UTF-8,', Param1) = 1;
If js Then
  cLine :=  UrlUnescape(Param1)
Else If (Pos(':\', Param1) = 2) And FileExists(Param1) Then
  begin
    html := StrLoadFromFile(Param1);
    If Pos('<', html) = 1 Then cLine := '/format=phf';
    settPos := Pos(settStart, html);
    If settPos <> 0 Then
      begin
      qsett := Copy(html, settPos+21, MaxInt);
      SetLength(qsett, Pos(settEnd, qsett)-1);
      cLine := cLine + ' ' + Utf8ToAnsi(qsett);
      StrReplace(html, settStart+qsett+settEnd, '');
      StrSaveToFile(Param1, html);
      end;
  end;

sFormat := GetParam(cLine, 'format');
sMethod := GetParam(cLine, 'method');
sUrl := GetParam(cLine, 'url');
sPath := GetParam(cLine, 'path');
sText := GetParam(cLine, 'text');

If (sMethod = 'all') And (Not JustOne(Form, 'JustOne_Qsaver')) Then Halt;

// Ini read
Qsini := OpenIniFile(QsaverIni);
Qsini.Mode := ifmRead;
Qsini.Section := 'Main';
FolderForPages := CorrectPath(Qsini.ValueString('QuickSaveDir', startDir), startDir);
QuickSaveDir := IncludeTrailingPathDelimiter(FolderForPages);
FolderForImages := CorrectPath(Qsini.ValueString('QuickSaveImgDir', QuickSaveDir + '_Images'), startDir);
QuickSaveImgDir := IncludeTrailingPathDelimiter(FolderForImages);
OperaOld := Qsini.ValueInteger('OperaVersion', 9) < 9;
Description := Qsini.ValueBoolean('Description', false);
ReverseOrder := Qsini.ValueBoolean('ReverseOrder', false);
History := Qsini.ValueBoolean('History', True);
English := Qsini.ValueBoolean('English', True);
TimeOut := Qsini.ValueInteger('TimeOut', 4) * 1000;
CheckParent := Qsini.ValueBoolean('CheckParent', True);

ChmOptions := Qsini.ValueString('ChmOptions', '262432,,1056828,[10,10,810,610],,,,1,,,0');
IsiloOptions := Qsini.ValueString('IsiloOptions', '<LinkOptions><FollowOffsite value="no"/></LinkOptions>');

Qsini.Section := 'Position';
Form.Left := Qsini.ValueInteger('Left', Form.Left );
Form.Top := Qsini.ValueInteger('Top', Form.Top );
Qsini.Free;

If Not DirectoryExists(QuickSaveDir) Then ForceDirectories(QuickSaveDir);
RootQsd := QuickSaveDir;
DefExt := '.htm';
Tip := 2;

// Converter files
converter := '';
If sFormat = 'chm' Then converter := 'hhc.exe';
If sFormat = 'pdb' Then converter := 'isiloxc.exe';
If converter <> '' Then
  begin
  sFormat := 'html';
  If FileExists(startDir+converter) Then
    OperaOld := false
  Else
    begin
    MessageBox( 0, PChar('Converter "'+startDir+converter+'" not found!'), QsErr,  48 );
    Halt
    end;
  end;
If sMethod = '' Then If converter <> '' Then sMethod := 'quick' Else sMethod := 'simple';

// Setup
If ParamCount = 0 Then
  begin
  Form.Style := Form.Style and not (WS_THICKFRAME Or WS_MAXIMIZEBOX);
  Form.ExStyle := Form.ExStyle or WS_EX_TOOLWINDOW;
  EditBox1.Text := FolderForPages;
  EditBox2.Text := FolderForImages;
  CheckBox1.Checked := History;
  CheckBox2.Checked := Not OperaOld;
  CheckBox3.Checked := English;
  CheckBox4.Checked := Description;
  CheckBox5.Checked := ReverseOrder;
  Lang(English);
  Button3.Focused := True;
  Label3.Enabled := CheckBox1.Checked;
  CheckBox5.Enabled := CheckBox1.Checked;
  Form.StayOnTop := True;
  Form.Visible := True;
  end
Else
  begin
  // Find Opera
  If CheckParent Then RecOpera.ProcId := GetParentId Else RecOpera.ProcId := 0;
  EnumWindows(@FindOpera, LongInt(@RecOpera));
  OpWnd := RecOpera.Wnd;
  If OpWnd = 0 Then
    begin
    MessageBox( 0, PChar('The window of Opera is not found!'), QsErr,  48 );
    Halt;
    end;

  // Check free size
  If Int64(DiskFreeSpace(ExtractFileDrive(QuickSaveDir))) < Int64(4194304) Then
    If MessageBox( 0, PChar('There is not enough free space on the disk!' + #13 + 'Are you sure what want to continue?'), QsErr,  49 ) = 2 Then Halt;

  // Get title
  TitleLen := GetWindowTextLength(OpWnd);
  If TitleLen > 0 Then
    begin
      SetString(Title, nil, TitleLen);
      GetWindowText(OpWnd, PChar(Title), TitleLen + 1);
      operaPos := PosR(' - Opera', Title);
      If operaPos > 0 Then SetLength(Title, operaPos - 1);
    end
  Else Title := '';

  RecOpera.Title := Title;
  NameFile := UrlUnescape(CorrectName(Title));
  If NameFile = '' Then NameFile := 'untitled';

  // Save via js
  If js And ((sFormat = 'htm') Or (sFormat = 'html') Or (sFormat = 'mht') Or (sFormat = 'txt')) Then
    begin
    Sleep(50);
    If HiWord(GetKeyState(VK_CONTROL)) = 0 Then keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
    If HiWord(GetKeyState(VK_S)) = 0 Then keybd_event(VK_S, MapVirtualKey(VK_S, 0), 0, 0);
    Sleep(50);
    keybd_event(VK_S, MapVirtualKey(VK_S, 0), KEYEVENTF_KEYUP, 0);
    keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
    end;

  simple := sMethod = 'simple';
  all := sMethod = 'all';
  folder := sMethod = 'folder';
  folderTime := sMethod = 'folder-time';
  folderName := sMethod = 'folder-name';
  quick := (sMethod = 'quick') Or folder Or folderTime Or folderName Or all;
  img := ((sFormat = 'img') Or (sFormat = 'imgs')) And (Not all);

  QuickText := CorrectName(sText);

  If img Then
    begin
    QuickSaveDir := QuickSaveImgDir;
    OperaOld := false;
    DefExt := '.jpg';
    Tip := 0;
    If sFormat = 'imgs' Then
      begin
      Sleep(50);
      If HiWord(GetKeyState(VK_CONTROL)) = 0 Then keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
      If HiWord(GetKeyState(VK_LBUTTON)) = 0 Then mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
      Sleep(50);
      mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
      keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
      TimeOut := TimeOut div 2;
      end;
    end;

  If sPath <> '' Then QuickSaveDir := IncludeTrailingPathDelimiter(CorrectPath(sPath, QuickSaveDir));

  If folder And (sUrl <> '') Then
    QuickSaveDir := QuickSaveDir + CorrHostName(sUrl)
  Else
    If folderTime Then
      QuickSaveDir := QuickSaveDir + IncludeTrailingPathDelimiter(Date2StrFmt('yyyyMMdd', Date)+Time2StrFmt('HHmmss', Now))
    Else
      If folderName Then
        begin
        If QuickText <> '' Then
          begin
          NameFile := QuickText;
          QuickText := '';
          end;
        QuickSaveDir := QuickSaveDir + IncludeTrailingPathDelimiter(NameFile);
        end;

  If Not DirectoryExists(QuickSaveDir) Then ForceDirectories(QuickSaveDir);

  // Main Work
  If sFormat = 'png' Then
      begin
      If all Then
       OpWinWnd := OpWnd
      Else
        begin
        EnumChildWindows(OpWnd, @GetChildWindow, LongInt(@RecOpera));
        OpWinWnd := FindWindowEx(FindWindowEx(FindWindowEx(FindWindowEx(RecOpera.WndScreen, 0, 'OperaWindowClass', nil), 0, 'OpWindow', nil), 0, 'OperaWindowClass', nil), 0, 'OperaWindowClass', nil);
        If (OpWinWnd = 0) Then OpWinWnd := OpWnd;
        end;

      If GetForegroundWindow <> OpWnd Then
        begin
          if IsIconic(OpWnd) then ShowWindow(OpWnd, SW_RESTORE);
          SetForegroundWindow(OpWnd);
          time := GetTickCount + TimeOut*2;
          While (GetForegroundWindow <> OpWnd) And (GetTickCount < time) Do Sleep(200);
          Sleep(500)
        end;
        If QuickText <> '' Then NameFile := QuickText;
        If quick And Not all Then
          begin
          rez := QuickSaveName(QuickSaveDir+NameFile + '.png');
          GetScreenShot(OpWinWnd, rez);
          If History Then AddToHistory(NameFile, rez, sUrl, RootQsd, all, ReverseOrder);
          If Description Then AddToDescription(rez, sUrl, false);
          end
        Else
          begin
          OSD := NewOpenSaveDialog('', '', DefOpenSaveDlgOptions );
          OSD.Filter := 'Portable Network Graphics (*.png)|*.png';
          OSD.Filename := NameFile + '.png';
          OSD.WndOwner := OpWnd;
          OSD.OpenDialog := false;
          If OSD.Execute Then
            begin
            Sleep(100);
            GetScreenShot(OpWinWnd, OSD.Filename, all);
            end;
          OSD.Free;
          end;
      end
  Else If sFormat = 'phf' Then
    begin
      If QuickText <> '' Then NameFile := QuickText;
      If quick Then
        begin
        rez := QuickSaveName(QuickSaveDir+NameFile + '.html');
        CopyFile(PChar(Param1), PChar(rez), false);
        If History Then AddToHistory(NameFile, rez, sUrl, RootQsd, all, ReverseOrder);
        If Description Then AddToDescription(rez, sUrl, false);
        end
      Else
        begin
        OSD := NewOpenSaveDialog('', '', DefOpenSaveDlgOptions );
        OSD.Filter := 'HTML Document (*.html)|*.html';
        OSD.Filename := NameFile + '.html';
        OSD.WndOwner := OpWnd;
        OSD.OpenDialog := false;
        If OSD.Execute Then CopyFile(PChar(Param1), PChar(OSD.Filename), false);
        OSD.Free;
        end;
      DeleteFile(PChar(Param1));
    end
  Else
    begin
      If all And (Not OperaOld) Then time := GetTickCount + TimeOut*3 Else time := GetTickCount + TimeOut;
      repeat
        If GetTickCount > time Then Halt;
        Sleep(100);
        SaveWnd := GetForegroundWindow;
        GetClassName(SaveWnd, SaveClass, SizeOf(SaveClass));
        GetWindowText(SaveWnd, SaveTitle, SizeOf(SaveTitle));
        If all And (Not OperaOld) Then Sleep(400);
      until IsWindowVisible(SaveWnd) And (SaveClass = '#32770') And (GetForegroundWindow = SaveWnd);

      repeat
      If all Then
        begin
        Sleep(200);
        time := GetTickCount + TimeOut;
        repeat
        If GetTickCount > time Then Halt;
        Sleep(200);
        SaveWnd := FindWindow('#32770', SaveTitle);
        If (Not OperaOld) And (SaveWnd <> 0) Then
          begin
          SendMessage(SaveWnd, WM_SYSCOMMAND, SC_HOTKEY, SaveWnd);
          Sleep(100);
          EnableWindow(SaveWnd, false);
          Sleep(100);
          EnableWindow(SaveWnd, True);
          end;
        until IsWindowVisible(SaveWnd);
        end;

      If SaveWnd <> 0 Then
        begin
        If sFormat = 'htm' Then Tip := 0;
        If sFormat = 'html' Then Tip := 1;
        If sFormat = 'mht' Then Tip := 2;
        If sFormat = 'txt' Then If OperaOld Then Tip := 2 Else Tip := 3;
        EnumChildWindows(SaveWnd, @GetHndls, LongInt(@RecOpera));
        Ewnd := RecOpera.WndEdit;
        SelWnd := RecOpera.WndCombo;

     // Simple save   
        SendMessage(Ewnd, WM_GETTEXT, SizeOf(text), Integer(@text));
        If simple And (QuickText <> '') Then
          SendMessage(Ewnd, WM_SETTEXT, 0, Integer(CorrectDot(QuickText)))
        Else
          begin
          If (text = '') Or (text = DefExt) Or (OperaOld And simple And (Pos(text, Title) = 0)) Or (simple And NeedCorrectName(text)) Then
            SendMessage(Ewnd, WM_SETTEXT, 0, Integer(CorrectDot(NameFile)))
          Else If Not OperaOld And WrongExt(text, sFormat) Then SendMessage(Ewnd, WM_SETTEXT, 0, Integer(CorrectDot(CorrectName(ExtractFileNameWOext(text)))));
          end;
        SendMessage(SelWnd, CB_SETCURSEL, 0, 0);
        SendMessage(SaveWnd, WM_COMMAND, MakeWparam(GetDlgCtrlId(SelWnd),CBN_SELCHANGE), SelWnd);
        SendMessage(SaveWnd, WM_COMMAND, MakeWparam(GetDlgCtrlId(SelWnd),CBN_SELENDOK), SelWnd);
        SendMessage(SelWnd, CB_SETCURSEL, Tip, 0);
        SendMessage(SaveWnd, WM_COMMAND, MakeWparam(GetDlgCtrlId(SelWnd),CBN_SELCHANGE), SelWnd);
        SendMessage(SaveWnd, WM_COMMAND, MakeWparam(GetDlgCtrlId(SelWnd),CBN_SELENDOK), SelWnd);

        
        If quick Then
          begin
          If OperaOld And (Not all) Then
            begin
            j := 0;
            If QuickText <> '' Then NameFile := QuickText;
            fn := QuickSaveDir + TrimR(Copy(NameFile, 1, 64));
            QuickSaveDir := fn + '_files\';
            while DirectoryExists(QuickSaveDir) do
              begin
                inc(j);
                QuickSaveDir := fn+'_'+int2str(j)+'_files\';
              end;
            CreateDir(QuickSaveDir);
            end;

          If (text <> '') And (text <> DefExt) Then
            begin
            SendMessage(Ewnd, WM_GETTEXT, SizeOf(text), Integer(@text));
            NameFile := text;
            end;

          If (QuickText <> '') And (Not OperaOld Or all) Then NameFile := QuickText;

          Ext := ExtractFileExt(NameFile);
          If Not all Then Fext := ExtractFileExt(sUrl) Else Fext := '';
          If NotHtmExt(Ext) And NotMmExt(Ext) Then
            If Not NotMmExt(Fext) Then
              NameFile := NameFile+Fext
            Else
              case Tip of
              0: NameFile := NameFile+DefExt;
              1: NameFile := NameFile+'.html';
              2: If OperaOld Then NameFile := NameFile+'.txt' Else NameFile := NameFile+'.mht';
              3: NameFile := NameFile+'.txt';
              end;


          Ext := ExtractFileExt(NameFile);
          NameFile := CorrectName(Copy(NameFile, 1, Length(NameFile)-Length(Ext)))+Ext;

          If NotHtmExt(Ext) Then converter := '';
          If converter <> '' Then
            begin
            tmpFolder := GetUniqTmpFolder(QuickSaveDir);
            CreateDir(tmpFolder);
            rez := QuickSaveName(tmpFolder+'\index.htm');
            end
          Else rez := QuickSaveName(QuickSaveDir+NameFile);

          SendMessage(Ewnd, WM_SETTEXT, 0, Integer(rez));
          Sleep(100);
          SendMessage(GetNextWindow(FindWindowEx(SaveWnd, 0, 'Button', nil), GW_HWNDNEXT), BM_CLICK, 0, 0);

          RezTitle := UrlUnescape(TrimL(TrimR(Title)));
          If RezTitle = '' Then RezTitle := 'untitled';

      // Save in CHM and iSilo
          If converter <> '' Then
            begin
            maxTime := GetTickCount + TimeOut*3;
            repeat
            tmpSize := GetFolderSize(tmpFolder);
            Sleep(100);
            until ( (tmpSize > 0) And (tmpSize = GetFolderSize(tmpFolder)) ) Or (GetTickCount > maxTime);
            Sleep(100);
            If all Then NameFile := ExtractFileNameWOext(NameFile) Else If QuickText <> '' Then NameFile := QuickText Else NameFile := CorrectName(RezTitle);

            If converter = 'hhc.exe' Then
              begin
              for k := Length(RezTitle) downto 1 do if RezTitle[k] = '"' then RezTitle[k] := '''';
              convSett := #13#10+'[WINDOWS]'+#13#10+'main="'+RezTitle+'",,,"index.htm",,,,,,'+ChmOptions+#13#10+'[FILES]'+GetAllFiles(tmpFolder);
              rez := QuickSaveName(QuickSaveDir+NameFile+'.chm');
              convSett := '[OPTIONS]'+#13#10+'Compatibility=1.1 or later'+#13#10+'Compiled file='+rez+#13#10+'Default window=main'+#13#10+'Default topic=index.htm'+convSett;
              convSettPath := tmpFolder+'\default.hhp';
              convCmdLine := ' "'+convSettPath+'"';
              CorrectHtmlFiles(tmpFolder);
              end;
            If converter = 'isiloxc.exe' Then
              begin
              rez := QuickSaveName(QuickSaveDir+NameFile+'.pdb');
              convSett := '<?xml version="1.0"?>'+#13#10+'<iSiloXDocumentList>'+#13#10+'<iSiloXDocument>'+#13#10+'<Source>'+#13#10+'<Sources>'+#13#10+'<Path>'+tmpFolder+'\index.htm'+'</Path>'+#13#10+'</Sources>'+#13#10+'</Source>';
              convSett := convSett + #13#10+'<Destination>'+#13#10+'<Title>'+RezTitle+'</Title>'+#13#10+'<Files>'+#13#10+'<Path>'+rez+'</Path>'+#13#10+'</Files>'+#13#10+'</Destination>';
              convSett := convSett + #13#10+IsiloOptions+#13#10+'</iSiloXDocument>'+#13#10+'</iSiloXDocumentList>';
              convSettPath := tmpFolder+'\isiloxc.ixl';
              convCmdLine := ' -x "'+convSettPath+'"';
              end;

            StrSaveToFile(convSettPath, convSett);
            ExecAndWait(startDir+converter+convCmdLine, SW_HIDE);
            DoFileOp(tmpFolder, '', FO_DELETE, FOF_NOCONFIRMATION or FOF_SILENT, '');
            end;

          If Not all Then
            begin
            If OperaOld Then SaveAddFile(rez, sUrl);
            If Description Then AddToDescription(rez, sUrl, OperaOld);
            end;

          If img Then RezTitle := text+' ('+RezTitle+')';
          If History Then AddToHistory(RezTitle, rez, sUrl, RootQsd, all, ReverseOrder);

          end;
        end;
      until Not all;
  end;
AppletTerminated := True;
end;

end;

procedure TForm1.Button4Click(Sender: PObj);
begin
Form.Close;
end;

procedure TForm1.CheckBox3Click(Sender: PObj);
begin
Lang(CheckBox3.Checked);
Button3.Focused := True;
end;

procedure TForm1.Button1Click(Sender: PObj);
var fDirList: POpenDirDialog;
begin
  fDirList:=NewOpenDirDialog('',[]);
  fDirList.WndOwner := Form.Handle;
  fDirList.InitialPath:=EditBox1.Text;
  If fDirList.Execute Then EditBox1.Text := fDirList.Path;
  fDirList.Free;
  Button3.Focused := True;
end;

procedure TForm1.Button2Click(Sender: PObj);
var fDirList: POpenDirDialog;
begin
  fDirList:=NewOpenDirDialog('',[]);
  fDirList.WndOwner := Form.Handle;
  fDirList.InitialPath:=EditBox2.Text;
  If fDirList.Execute Then EditBox2.Text := fDirList.Path;
  fDirList.Free;
  Button3.Focused := True;
end;

procedure TForm1.Button3Click(Sender: PObj);
var Qsini: pIniFile;
begin
Qsini := OpenIniFile(ReplaceExt(ParamStr(0), '.ini'));
Qsini.Mode := ifmWrite;
Qsini.Section := 'Main';
If FolderForPages <> EditBox1.Text Then Qsini.ValueString('QuickSaveDir', EditBox1.Text);
If FolderForImages <> EditBox2.Text Then Qsini.ValueString('QuickSaveImgDir', EditBox2.Text);

If CheckBox2.Checked Then Qsini.ValueInteger('OperaVersion', 9) Else Qsini.ValueInteger('OperaVersion', 8);
Qsini.ValueBoolean('History', CheckBox1.Checked);
Qsini.ValueBoolean('English', CheckBox3.Checked);
Qsini.ValueBoolean('Description', CheckBox4.Checked);
Qsini.ValueBoolean('ReverseOrder', CheckBox5.Checked);

Qsini.Section := 'Position';
Qsini.ValueInteger('Left', Form.Left );
Qsini.ValueInteger('Top', Form.Top );
Qsini.Free;
Form.Close;
end;

procedure TForm1.CheckBox1Click(Sender: PObj);
begin
Label3.Enabled := CheckBox1.Checked;
CheckBox5.Enabled := CheckBox1.Checked;
Button3.Focused := True;
end;

procedure TForm1.CheckBox4Click(Sender: PObj);
begin
Button3.Focused := True;
end;

procedure TForm1.CheckBox2Click(Sender: PObj);
begin
Button3.Focused := True;
end;

procedure TForm1.Label3Click(Sender: PObj);
begin
ShellExecute(0, 'open', PChar(IncludeTrailingPathDelimiter(EditBox1.Text)+'QSaverHistory.html'), nil, nil, SW_SHOWNORMAL);
end;

end.


